#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <mysql.h>
#include <unistd.h>
#include <stdlib.h>

/*
LinuxSagra
	Sistema per la gestione di cassa, cameriere e cucina di una
	sagra paesana

medie.c
	programmino da mettere in qualche crontab che calcola le medie
	dei tempi di (inter)servizio, producendo una tabellina HTML
	in output.
                
Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           */


// una serie di sani default...
#ifndef HOST
#define HOST		"localhost"
#endif

#ifndef DBNAME
#define DBNAME		"Cimpello"
#endif

#ifndef MEDIE_HTML
#define MEDIE_HTML	"/var/web/webspace/Sagra/medie.phtml"
#endif

// la query, definiamola qui che  pi bello... ;)))
// ritorna (almeno) tre righe, una per C, A, V con cui, tramite
// sottrazioni rispettive, ottengo le medie effettive
//#define QUERY "SELECT Servizio,AVG(UNIX_TIMESTAMP(Tstamp)) AS Media FROM Ordine,Storia,Volontario,Tavolo WHERE (Ordine.Nordine=Storia.Nordine AND Ordine.DataOrdine=Storia.DataOrdine AND Ordine.Nordine=Tavolo.Nordine AND Ordine.DataOrdine=Tavolo.DataOrdine AND Storia.IDVolontario=Volontario.IDVolontario AND Stato = 'E') GROUP BY Servizio"
#define QUERY "SELECT Servizio,AVG(UNIX_TIMESTAMP(Tstamp)) AS Media FROM Ordine NATURAL LEFT JOIN Storia NATURAL LEFT JOIN Volontario,Tavolo WHERE (Ordine.Nordine=Tavolo.Nordine AND Ordine.DataOrdine=Tavolo.DataOrdine AND Stato = 'E') GROUP BY Servizio"


// devo anche commentarla?! ;)
void help (void) {

printf ("medie, calcola le medie dei tempi di (inter)servizio\n\n");
printf ("medie comes with ABSOLUTELY NO WARRANTY;\n");
printf ("This is free software, and you are welcome to redistribute it\n");
printf ("under certain conditions; see GNU GPL version 2 or above for detail\n\n");
printf ("USO:\tmedie\n\n");
printf ("produce nel file %s\n",MEDIE_HTML);
printf ("una tabellina HTML con le medie dei tempi di (inter)servizio\n");
printf ("(programmino inteso per essere lanciato da crontab)\n\n");
printf ("Report bug to gaio@pluto.linux.it\n");

}




void main(int argc, char *argv) {

FILE		*fd;		// il file descriptor della pagina html...
MYSQL 		*conn;		// la connessione al server...
MYSQL_RES	*res;		// il risultato della query...
MYSQL_ROW	riga;		// una riga della query...

int		C,		// tempo medio in cassa
		A,		// tempo medio alle cameriere
		V;		// tempo medio in cucina


// un controllino su quello che mi passano, stampo l'help e il copyright
// GNU
if ( argc != 1) {
	help();
	exit(-1);
}

// apriamo il file...
if ( (fd = fopen(MEDIE_HTML, "w")) == NULL ) {
	perror("errore aprendo il file");
	exit(-1);
}

// connettiamoci...
if ( (conn = mysql_connect(NULL, HOST, getlogin(), "")) < 0 ) {
	printf("errore connettendomi al server MySQL\n");
	printf("errore: %s\n", mysql_error(conn));
	exit(-1);
}

// selezion il database...
if ( mysql_select_db(conn, DBNAME) < 0 ) {
	printf("errore selezionando il database %s!\n", DBNAME);
	printf("errore: %s\n", mysql_error(conn));
	exit(-1);
}

// una bella query...
if ( mysql_query(conn, QUERY) < 0 ) {
	printf("errore eseguendo la query!\n");
	printf("errore: %s\n", mysql_error(conn));
	exit(-1);
}

// ora prendiamoci il risultato...
if ( (res = mysql_store_result(conn)) == NULL ) {
	printf("errore agguantando il risultato!\n");
	printf("errore: %s\n", mysql_error(conn));
	exit(-1);
}

// veediamo quante righe ci sono...
if ( mysql_num_rows(res) != 3 ) {
	C = 0;	
	A = 0;
	V = 0;
} else {
	// perfetto, ci sono le tre righe che ci servono...
	// ora un bel loop e preleviamo i valori.
	
	int i = 0;
	while ( i < 3 ) {

		// preleviamo una riga...
		if ( (riga = mysql_fetch_row(res)) == NULL ) {
			printf("errore agguantando la riga!\n");
			printf("errore: %s\n", mysql_error(conn));
			exit(-1);
		}

		if ( strcmp(riga[0], "C") == 0 ) {
			C = (int) strtod(riga[1], NULL);
		} else if ( strcmp(riga[0], "A") == 0 ) {
			A = (int) strtod(riga[1], NULL);
		} else if ( strcmp(riga[0], "V") == 0 ) {
			V = (int) strtod(riga[1], NULL);
		}
	
	// me lo dimentico sempre...
	i++;
	
	} // while

} // else

// ottimo, ora scriviamo un aborto di pagina html... lo faciamo anche con
// degli zeri, questa pagina  bene che esista sempre... ;)))
fprintf(fd,"<CENTER>\n");
fprintf(fd,"<TABLE WIDTH=100%%><TR>\n");
fprintf(fd,"<TD ALIGN=left>%i</TD>\n",(A-C)/60);
fprintf(fd,"<TD ALIGN=center>%i</TD>\n",(V-A)/60);
fprintf(fd,"<TD ALIGN=right>%i</TD>\n",(V-C)/60);
fprintf(fd,"</TR></TABLE>\n");
fprintf(fd,"</CENTER>\n");

// tutto finito, di gi...
fclose(fd);
mysql_close(conn);

} // main()
